;;; srd-fpw.el --- supplement file for إϥѸ켭ŵ
;; 2000/04/11
;;
;; Copyright (C) 2000 Keisuke Nishida <kxn30@po.cwru.edu>
;; Copyright (C) 2000 Kazuhiko Shiozaki <kazuhiko@ring.gr.jp>
;; Copyright (C) 2000 Kazuyoshi KOREEDA <k_koreed@d2.dion.ne.jp>

;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License
;; as published by the Free Software Foundation; either version 2
;; of the License, or (at your option) any later version.

;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software Foundation,
;; Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;;; Code:

(require 'lookup-package)
(require 'lookup-content)

; APEL ɬפǤ
(require 'poem)

(defvar srd-fpw-data-directory "/mnt/cdrom/DATA"
  "img.dat, srdra.bnd Τꡣ")
(defvar play-realaudio-process "realplay"
  "RealAudio ץ̾nil ʤʤ")
(defvar display-image-process "display"
  " ɽץ̾nil ʤɽʤ")
; ֤ʤפ̤Ǥ
;(defvar srd-fpw-sound-without-notice nil
;  "t ʤ鸡Ʊ˲롣")
(defvar display-image-inline t
  "nil ʤ (ǽʾǤ) 򥤥饤ɽʤ")

(defvar srd-fpw-tmp-dir temporary-file-directory "եκ")

(defconst srd-fpw-arranges
  '(lookup-arrange-gaijis
    srd-fpw-arrange-realaudio
    srd-fpw-arrange-images
    lookup-arrange-references
    lookup-arrange-default-headings
    lookup-arrange-fill-lines))

(defvar srd-fpw-dictionary-options
  (list (cons ':arranges srd-fpw-arranges)))

(defvar srd-fpw-process-file-alist '())

;; 
;; 餢 lookup-content-follow-linkγĥ
;; 
(unless (fboundp 'lookup-content-follow-link:old)
  (fset 'lookup-content-follow-link:old
	(symbol-function 'lookup-content-follow-link))
  (defun lookup-content-follow-link ()
    (interactive)
    (let ((action (get-text-property (point) 'action)))
      (if action 
	  (funcall action (point))
	(lookup-content-follow-link:old)))))

(defun srd-fpw-string-to-number (string)
  (let ((len (length string))
	(number 0) (i 0) c)
    (while (< i len)
      (setq number (* number 16))
      (setq c (aref string i))
      (cond
       ((and (<= ?0 c) (<= c ?9)) (setq number (+ number (- c ?0))))
       ((and (<= ?a c) (<= c ?f)) (setq number (+ number (- c ?a -10))))
       ((and (<= ?A c) (<= c ?F)) (setq number (+ number (- c ?A -10))))
       (t (setq i len)))
      (setq i (1+ i)))
    number))

(defun srd-fpw-arrange-images (entry)
  (while (re-search-forward
	  "<image=\\([^:]+\\):\\([^>]+\\)>" nil t)
    (let ((file "img.dat")
	  (offset (srd-fpw-string-to-number (match-string 1)))
	  (length (srd-fpw-string-to-number (match-string 2)))
	  (start (match-beginning 0))
	  (end (match-end 0)))
      ;; Find data file.
      (if (file-exists-p (expand-file-name file srd-fpw-data-directory))
	  (setq file (expand-file-name file srd-fpw-data-directory)))
;       ʤ饤ɽǤʤ...
;      (if (and display-image-inline
;	       (featurep 'xemacs)
;	       (eq window-system 'x))
	  (progn
;	    (replace-match "\n")
;	    (insert-file-contents-internal file nil offset (+ offset length)))
	(replace-match "[]")
	(add-text-properties start 
			     (+ (length "[]") start)
			     (list 'action 'srd-fpw-display-image
				   'file  file
				   'offset offset
				   'mouse-face 'highlight
				   'face 'lookup-reference-face
				   'size   length))))))

(defun srd-fpw-arrange-realaudio (entry)
  (while (re-search-forward
	  "<sound=\\([^:]+\\):\\([^>]+\\)>" nil t)
    (let ((file "srdra.bnd")
	  (offset (srd-fpw-string-to-number (match-string 1)))
	  (length (srd-fpw-string-to-number (match-string 2)))
	  (start (match-beginning 0))
	  (end (match-end 0)))
      ;; Find data file.
      (if (file-exists-p (expand-file-name file srd-fpw-data-directory))
	  (setq file (expand-file-name file srd-fpw-data-directory)))
      (replace-match "[]")
      (add-text-properties start 
			   (+ (length "[]") start)
			   (list 'action 'srd-fpw-play-realaudio
				 'file  file
				 'offset offset
				 'mouse-face 'highlight
				 'face 'lookup-reference-face
				 'size   length)))))
;;
;; ץѤ᡼ɽ
;;
(defun srd-fpw-display-image (pos)
  (let* ((file (get-text-property pos 'file))
	 (offset (get-text-property pos 'offset))
	 (size (get-text-property pos 'size))
	 (tmp-image-file (srd-fpw-write-tmp-file 
			  file offset (+ offset size))))
    (if display-image-process
	(srd-fpw-start-process display-image-process nil tmp-image-file t))))
;;
;; ץѤκ
;;
(defun srd-fpw-play-realaudio (pos)
  (let* ((file (get-text-property pos 'file))
	 (offset (get-text-property pos 'offset))
	 (size (get-text-property pos 'size))
	 (tmp-realaudio-file (srd-fpw-write-tmp-file 
			      file offset (+ offset size))))
    (if play-realaudio-process
	(srd-fpw-start-process play-realaudio-process nil tmp-realaudio-file t))))
;;
;; ץθƽФ
;; 
(defun srd-fpw-start-process (program options file &optional delete-file)
  (message "Starting %s ..." program)
  (let ((pro (apply (function start-process)
		    (format "*srd-fpw %s*" program)
		    nil
		    program
		    (append options (list file)))))
    (message "Starting %s ... done" program)
    (set-process-sentinel pro 'srd-fpw-start-process-sentinel)
    (setq srd-fpw-process-file-alist 
	  (cons (cons pro file) 
		(if delete-file 
		    srd-fpw-process-file-alist
		  nil)))))
;;
;; ץξ֤ѹ줿Ȥ˥ե롣
;;
(defun srd-fpw-start-process-sentinel (process event)
  (let ((al (assoc process srd-fpw-process-file-alist)))
    (and (cdr al) (delete-file (cdr al)))
    (setq srd-fpw-process-file-alist 
	  (delete al srd-fpw-process-file-alist))))
;;
;; եβɬפʬڤФ
;;
(defun srd-fpw-write-tmp-file (file beg end)
  (let ((tmp-file (make-temp-name 
		   (expand-file-name "srd-fpw" temporary-file-directory))))
    (with-temp-buffer
      (insert-file-contents-as-binary file nil beg end)
      (write-region-as-binary (point-min) (point-max) tmp-file))
    tmp-file))
  
(setq lookup-package-dictionary-options-alist
      (list (cons (cond ((eq lookup-package-agent 'ndtp) "SRD-FPW/SRD-FPW")
			((eq lookup-package-agent 'ndeb) "SRD-FPW"))
		  srd-fpw-dictionary-options)))

;;; srd-fpw.el ends here
